/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.ua.jtech.ejb;

import java.math.BigDecimal;
import java.math.MathContext;
import javax.ejb.Stateless;

/**
 *
 * @author especialista
 */
@Stateless
public class CalculoPI implements CalculoPILocal {

    private  BigDecimal serieArcotangente(double x, int iteraciones) {
        MathContext mc = new MathContext(500);
        BigDecimal result = new BigDecimal(0.00, mc);
        BigDecimal uno = new BigDecimal(1.00);
        for (int i = 0; i < iteraciones; i++) {
            double div = (2.00 * i + 1.00)
                    * (Math.pow(1.00 / x, 2.00 * i + 1.00));
            BigDecimal divisor = new BigDecimal(div);
            if (i % 2 == 0) {
                result = result.add(uno.divide(divisor, mc));
            } else {
                result = result.subtract(uno.divide(divisor, mc));
            }
        }
        return result;
    }
    
    private  BigDecimal calculoPiDase(){
        BigDecimal pi = serieArcotangente(1.00/2.00,100)
                .add(serieArcotangente(1.00/5.00,100))
                .add(serieArcotangente(1.00/8.00,100))
                .multiply(new BigDecimal(4.00));
        return pi;
    }        
    
    @Override
    public BigDecimal calcular() {
        return calculoPiDase();
    }       
}
